您的位置:首页 > 编程语言 > Java开发

Combination Sum IV中两种JAVA动态规划解法的不同

2017-04-08 15:06 232 查看
leetcode题目:https://leetcode.com/problems/combination-sum-iv/#/description

Given an integer array with all positive numbers and no duplicates,

find the number of possible combinations that add up to a positive

integer target.

Example:

nums = [1, 2, 3] target = 4

The possible combination ways are: (1, 1, 1, 1) (1, 1, 2) (1, 2, 1)

(1, 3) (2, 1, 1) (2, 2) (3, 1)

Note that different sequences are counted as different combinations.

solution 1 : (correct one)

public class Solution {

public int combinationSum4(int[] nums, int target) {
// 在递归过程中,如果状态集是有限的,我们可以采用动态规划的方法,把每个状态的结果记录下来,以减少计算量。
int[] dp = new int[target + 1];
dp[0] = 1;
for (int i = 1; i < dp.length; i++) {        //  outer loop is  to  traversal  dp array
for (int j = 0; j < nums.length; j++) {    // inner loop is to  traversal  nums array
if (i - nums[j] >= 0) {
dp[i] += dp[i - nums[j]];
}
}
}
return dp[target];
}

}


solution 2:(wrong one )

public class Solution {

public int combinationSum4(int[] nums, int target) {
int [] dp = new int[target + 1];

dp[0] = 1;
for (int i = 0; i < nums.length; i++) {        //  outer loop is  to  traversal  nums array and nums array should be ASC ordered
for (int j = nums[i]; j <= target; j++) {   //  inner loop is to  traversal  dp array
dp[j] += dp[j - nums[i]];
}
}
return dp[target];
}

}


when give a testcase:

nums = [1, 2, 3]

target = 4

solution 1 got the answer 7:

The possible combination ways are:

(1, 1, 1, 1)

(1, 1, 2)

(1, 2, 1)

(1, 3)

(2, 1, 1)

(2, 2)

(3, 1)

i wanna say this is Permutations not combination.

solution 2 give the answer 4, Obviously, delete the same combination from the above possible Permutations, eg (1, 1, 2) (1, 2, 1) (2, 1, 1) (1, 3) (3, 1), the answer is 4.

so, solution 1 could get the Permutation Sum, and solution 2 could get the Combination Sum. this is because the count order of dp and nums is different.
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签:  leetcode 动态规划 java